(* Title: tests for AList
   Author: Walther Neuper
   Use is subject to license terms.
*)

"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------";
"-----------------------------------------------------------------------------";
"-------- fun AList.lookup, fun AList.update ---------------------------------";
"-------- fun AList.merge ----------------------------------------------------";
"-----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------";


"-------- fun AList.lookup, fun AList.update ---------------------------------";
"-------- fun AList.lookup, fun AList.update ---------------------------------";
"-------- fun AList.lookup, fun AList.update ---------------------------------";
val al = [("a", 1), ("b", 2), ("c", 3)];
if AList.lookup (op =) al "b" = SOME 2
then () else error "AList.lookup changed";
if AList.update (op =) ("b", 2) al = [("a", 1), ("b", 2), ("c", 3)]
then () else error "AList.update changed 1";
if AList.update (op =) ("x", 999) al = [("x", 999), ("a", 1), ("b", 2), ("c", 3)]
then () else error "AList.update changed 2";

"-------- fun AList.merge ----------------------------------------------------";
"-------- fun AList.merge ----------------------------------------------------";
"-------- fun AList.merge ----------------------------------------------------";
val al = [("a", 1), ("b", 2), ("c", 3)];
if AList.merge (op =) (op =) (al, al) = [("a", 1), ("b", 2), ("c", 3)]
then () else error "AList.merge changed 1";
if AList.merge (op =) (op =) (al, [("x", 999)]) = [("x", 999), ("a", 1), ("b", 2), ("c", 3)]
then () else error "AList.merge changed 2";

